# Oxydif.bas
s$(2)="# elmts"
s$(3)="20"
s$(4)="fg (m3/m3)"
s$(5)="0.2"
s$(6)="e-lngth (m)"
s$(7)="0.05"
f=form(12,0,"Oxydif inputs")
if f=0 then end
m=val(s$(3))
fg=val(s$(5))
x=val(s$(7))
dim A(M+1),B(M),C(M),K(M),CO(M),D(M),U(M),Z(M+1),DF(M)
Z(0)=0: Z(1)=0 : K(0)=0.01 : CO(0)=280
for I=1 to M                   
     Z(I+1)=Z(I)+X
      DF(I)=0.0000177*.9*FG^2.3
      U(I)=-0.0005*(Z(I+1)-Z(I-1))/2*exp(-Z(I)/0.3)
if I<M then
   K(I)=DF(I)/(Z(I+1)-Z(I)) else K(I)=0
endif
     A(I+1)=-K(I)
     B(I)=K(I-1)+K(I) 
     C(I)=-K(I)                                      
     D(I)=U(I)                                                
next                                            
D(1)=D(1)+K(0)*CO(0) 
for I=1 to M-1                                
     C(I)=C(I)/B(I)  
     D(I)=D(I)/B(I)                                           
     B(I+1)=B(I+1)-A(I+1)*C(I)  
     D(I+1)=D(I+1)-A(I+1)*D(I)                                
next                    
CO(M)=D(M)/B(M)  
for I=M-1 to 1 step -1
     CO(I)=D(I)-C(I)*CO(I+1)  
next  
draw -1
draw "Oxygen Flux =  ",0,20
draw str$(K(0)*(CO(0)-CO(1))*1e6)+" "+chr$(181)+"g/(m2-s)",20,30
draw "Soil Oxygen Diffusion Coefficient =",0,50
draw str$(df(1))+" m2/s",20,60
draw "Soil-Element Oxygen Conductance =",0,80
draw str$(k(1)*1e6)+" "+chr$(181)+"m/s",20,90
draw "Boundary Conditions:",0,110
draw "Upper:",15,120
draw "O2 = "+str$(co(0))+" g/m3",60,120
draw "Lower:",15,130
draw "K = 0 m/s",65,130
fn pen(0)
g%=int(m/8)+1
for j=1 to g%
    draw -1 
    draw "Depth",0,20
    draw " O2 Conc",75,20 
    draw "  (m)",0,30
    draw " (g/m3)",75,30     
    if j<g% then
      k=1
      for I=(j-1)*8 to (j*8-1)
        if i=0 then
          draw "air",0,40+(k*10)
         else
           draw str$(Z(I)),0,40+(k*10)
        endif
        draw str$(CO(I)),75,40+(k*10)
        k=k+1 
       next
    endif
    if j=g% then
        k=1
        for I=(j-1)*8 to M 
        if i=0 then
          draw "air",0,40+(k*10)
         else
           draw str$(Z(I)),0,40+(k*10)
        endif
        draw str$(CO(I)),75,40+(k*10)
          k=k+1
        next 
    endif
 fn pen(0)
next
for j=1 to g%
    draw -1 
    draw "Depth",0,20
    draw "U",100,20 
    draw "   m",0,30
    draw chr$(181)+"g/(m2-s) ",85,30     
    if j<g% then
      k=1
      for I=(j-1)*8 to (j*8-1) 
        if i=0 then
          draw "air",0,40+(k*10)
         else
           draw str$(Z(I)),0,40+(k*10)
        endif
        draw str$(u(i)*1e6),75,40+(k*10)
        k=k+1 
       next
    endif
    if j=g% then
        k=1
        for I=(j-1)*8 to M 
        if i=0 then
          draw "air",0,40+(k*10)
         else
           draw str$(Z(I)),0,40+(k*10)
        endif
          draw str$(u(i)*1e6),75,40+(k*10)
          k=k+1
        next 
    endif
fn pen(0)
next
totalU=0
for i=1 to m
 totalU=totalU+u(i)
next
draw "Total Consumption Rate = ",0,40+(k*10)
draw str$(totalU*1e6)+" "+chr$(181)+"g/(m2-s)",50,40+((k+1)*10)
fn pen(0)
draw -1
draw 25,35,125,105,4
draw "Oxygen Conc (g/m3)",45,15
draw "   Z",0,55
draw "(cm)",0,65
draw str$(0),22,22
draw str$(300),142,22
dmax=round(m*x*100)
xdots=125/300
ydots=105/dmax
for i=1 to 3
 moveto 25+(i*75*xdots),35
 lineto 25+(i*75*xdots),40
 moveto 25+(i*75*xdots),135
 lineto 25+(i*75*xdots),140
next
draw str$(0),17,30
dgts=1
if dmax>=10 then dgts=2
if dmax>=100 then dgts=3
if dmax>=1000 then dgts=4
draw str$(dmax),22-dgts*5,130
for i=1 to 4
 moveto 25,35+i*round(dmax/5)
 lineto 30,35+i*round(dmax/5)
 moveto 150,35+i*round(dmax/5)
 lineto 145,35+i*round(dmax/5)
next
x1= round(25+xdots*co(1))
y1=round(35+(ydots*z(1)*100))
moveto x1,y1
for i=2 to m
  x1= round(25+xdots*co(i))
  y1=round(35+(ydots*z(i)*100))
   lineto x1,y1
next
for i=1 to m
  draw circle round(25+xdots*co(i)),round(35+(ydots*z(i)*100)),3,7
next
draw "Jg(0) =",37,145
draw str$(K(0)*(CO(0)-CO(1))*1e6)+" "+chr$(181)+"g/(m2-s)",65,145
fn pen(0)
end
